# This file was generated by mettle.genes.braze.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#

import datetime
import uuid
import mettle.braze
import mettle.lib

from mettle.io.iserializable import ISerializable

class bBatchInstQuery(ISerializable):

    def __init__(self,
                 date_from: datetime.datetime = None,
                 date_to: datetime.datetime = None,
                 batch_id: int = 0,
                 status: mettle.braze.CharList = None):
        """
        Constructor.

        :param date_from: Optinally specify a from date to search from
        :param date_to: Optinally specify a to date to search from
        :param batch_id: Limit the results by batch identifier
        :param status: Limit query to a status list
        """
        self.date_from = date_from
        self.date_to = date_to
        self.batch_id = batch_id
        self.status = mettle.braze.CharList() if status is None else status

    def clear(self):
        self.date_from = None
        self.date_to = None
        self.batch_id = 0
        self.status.clear()

    def _name(self) -> str:
        """
        Get the struct name.

        :return: Name of the struct
        """
        return 'bBatchInstQuery'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize this struct.

        :param _w:
        :param _oname:
        """
        if not _oname:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_datetime("dateFrom", self.date_from)
        _w.write_datetime("dateTo", self.date_to)
        _w.write_int64("batchId", self.batch_id)
        self.status._serialize(_w, "status")
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None) -> int:
        """
        Deserialize this struct.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.date_from = _r.read_datetime("dateFrom")
        self.date_to = _r.read_datetime("dateTo")
        self.batch_id = _r.read_int64("batchId")
        self.status._deserialize(_r, "status")
        _r.read_end(_oname)

    @staticmethod
    def _cache_davs(dvc: mettle.lib.DavCache = None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: Target cache, if None a new one is created and returned.
        """
        if not dvc:
            dvc = mettle.lib.DavCache()


        return dvc

    def _get_davs(self, dvc=None):
        return self._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<bBatchInstQuery [date_from:%s, date_to:%s, batch_id:%r, status:%r]>' % (
            self.date_from, self.date_to, self.batch_id, self.status)

    # List class
    class List(list, ISerializable):

        def _name(self) -> str:
            """
            Get list name
            """
            return 'bBatchInstQuery.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None) -> int:
            """
            Deserialize the list

            :param _r:
            :param _oname:
            """
            if _oname == None:
                  _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = bBatchInstQuery()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def _get_davs(self, dvc: mettle.lib.DavCache = None) -> int:
            """
            Cache the davs

            :param dvc:
            """
            return bBatchInstQuery._cache_davs(dvc)

        def __repr__(self) -> str:
            return '<bBatchInstQuery.List[%d]>' % (len(self))

