# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Mon Mar 14 20:34:08 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_item_by_batch_id import iBatchItemByBatchId
from bs_monitor.db.tables.batch_item import tBatchItem

class dBatchItemByBatchId:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchItemByBatchId()
        self.orec     = tBatchItem()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        batch_id: int,
                        criteria: str) -> "dBatchItemByBatchId":
        """
        Execute the query by setting all the inputs.

        :param batch_id: int
        :param criteria: str
        :return: Self for convenience.
        """
        self.irec.batch_id = batch_id
        self.irec.criteria = criteria

        return await self.exec()

    async def exec(self, irec: iBatchItemByBatchId = None) -> "dBatchItemByBatchId":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchItemByBatchId", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  i.*
from
  monitor.batchitem i
where
  i.batch_id = :batchId
  [criteria]
order by
  i.id""")

        self._dbstmnt.dynamic("[criteria]", self.irec.criteria)

        self._dbstmnt.bind_in("batchId", self.irec.batch_id, int, 8)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("batch_id", int, 8)
        self._dbstmnt.bind_out("job_id", int, 8)
        self._dbstmnt.bind_out("extra_args", str, 128)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.batch_id = self._dbstmnt.result[1]
        self.orec.job_id = self._dbstmnt.result[2]
        self.orec.extra_args = self._dbstmnt.result[3]
        self.orec.stamp_by = self._dbstmnt.result[4]
        self.orec.stamp_tm = self._dbstmnt.result[5]

        return True

    async def fetch_all(self, outList: tBatchItem.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

